/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.builders.snapshot;

import java.util.HashMap;
import java.util.Map;

import javax.annotation.Nullable;

import net.minecraft.util.math.ChunkPos;
import net.minecraft.world.chunk.Chunk;
import net.minecraft.world.chunk.IChunkProvider;

public class FakeChunkProvider implements IChunkProvider {
    private final FakeWorld world;
    public final Map<ChunkPos, Chunk> chunks = new HashMap<>();

    public FakeChunkProvider(FakeWorld world) {
        this.world = world;
    }

    @Nullable
    @Override
    public Chunk func_186026_b(int x, int z) {
        ChunkPos chunkPos = new ChunkPos(x, z);
        if (!chunks.containsKey(chunkPos)) {
            chunks.put(chunkPos, new Chunk(world, x, z) {
                @Override
                public void func_76603_b() {
                }
            });
        }
        return chunks.get(chunkPos);
    }

    @Override
    public Chunk func_186025_d(int x, int z) {
        return func_186026_b(x, z);
    }

    @Override
    public boolean func_73156_b() {
        return false;
    }

    @Override
    public String func_73148_d() {
        return "fake";
    }

    @Override
    public boolean func_191062_e(int x, int z) {
        return true;
    }
}
