/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.silicon.client.render;

import javax.annotation.Nonnull;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.util.ResourceLocation;

import net.minecraftforge.client.model.animation.FastTESR;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import buildcraft.silicon.tile.TileProgrammingTable_Neptune;

@SideOnly(Side.CLIENT)
public class RenderProgrammingTable extends FastTESR<TileProgrammingTable_Neptune> {
    @Override
    public void renderTileEntityFast(@Nonnull TileProgrammingTable_Neptune tile, double x, double y, double z, float partialTicks, int destroyStage, float partial, @Nonnull BufferBuilder buffer) {
        Minecraft.func_71410_x().field_71424_I.func_76320_a("bc");
        Minecraft.func_71410_x().field_71424_I.func_76320_a("table");
        Minecraft.func_71410_x().field_71424_I.func_76320_a("programming");

        TextureAtlasSprite sprite = Minecraft.func_71410_x().func_147117_R().func_174942_a(new ResourceLocation("blocks/glass_white"));
        int combinedLight = tile.func_145831_w().func_175626_b(tile.func_174877_v(), 0);
        int light1 = combinedLight >> 16 & 65535;
        int light2 = combinedLight & 65535;
        buffer.func_181662_b(x + 4 / 16D, y + 9 / 16D, z + 4 / 16D).func_181669_b(255, 255, 255, 255).func_187315_a(sprite.func_94214_a(4), sprite.func_94207_b(4)).func_187314_a(light1, light2).func_181675_d();
        buffer.func_181662_b(x + 12 / 16D, y + 9 / 16D, z + 4 / 16D).func_181669_b(255, 255, 255, 255).func_187315_a(sprite.func_94214_a(12), sprite.func_94207_b(4)).func_187314_a(light1, light2).func_181675_d();
        buffer.func_181662_b(x + 12 / 16D, y + 9 / 16D, z + 12 / 16D).func_181669_b(255, 255, 255, 255).func_187315_a(sprite.func_94214_a(12), sprite.func_94207_b(12)).func_187314_a(light1, light2).func_181675_d();
        buffer.func_181662_b(x + 4 / 16D, y + 9 / 16D, z + 12 / 16D).func_181669_b(255, 255, 255, 255).func_187315_a(sprite.func_94214_a(4), sprite.func_94207_b(12)).func_187314_a(light1, light2).func_181675_d();

        Minecraft.func_71410_x().field_71424_I.func_76319_b();
        Minecraft.func_71410_x().field_71424_I.func_76319_b();
        Minecraft.func_71410_x().field_71424_I.func_76319_b();
    }
}
